# Supplementary Materials
This is for the paper From SCAN to Real Data: Systematic Generalization via Meaningful Learning.

## Data
* SCAN
* GEO
* ADV

## Models
* RNN - bi_lstm_rnn_att
* CNN - cnn_att
* TFM - transformer

## Directory
* appendix.pdf - Paper Appendix
* data_augmentation - to find extra datasets for machine translation and semantic parsing
* config.py - to change the model and experimental configurations
* train.py - to start the training
* res/data - to find datasets used in experiments
* res/data/prepare-iwslt15.sh - to prepare data for IWSLT'15 in fairseq
* src - to find model details and helper functions
* requirements.txt - to install dependency
```
supplementary\ materials
├── README.md
├── appendix.pdf
├── data_augmentation
│   ├── mt
│   └── sp
├── main
│   ├── config.py
│   ├── res
│   │   └── data
│   │       ├── scan
│   │       ├── advising
│   │       ├── geography
│   │       └── prepare-iwslt15.sh
│   ├── src
│   │   ├── models
│   │   └── utils
│   └── train.py
└── requirements.txt
```

## Dependencies
+ python >= 3.8.5
+ torch >= 1.8.1
+ tqdm >= 4.49.0
+ numpy >= 1.19.2

## Setup
Please ensure required packages are already installed. A virtual environment is recommended.
```
$ pip install pip --upgrade
$ pip install -r requirements.txt
```

## Run
Before training, please take a look at the **config.py** to ensure training configurations.
```
$ vim config.py
$ python train.py
```

## Experiments
The *exp* in *config.py* stands for the following:
* exp0 - baselines
* exp1 - deductive learning standard
* exp2 - deductive learning difficult
* exp31 - inductive learning standard
* exp32 - inductive learning difficult
* exp33 - inductive learning challenging
* epx41 - semantic parsing without data augmentation
* exp42 - semantic parsing with data augmentation

## Machine Translation
Please find dataset from *data_augmentation/mt* and conduct experiments following fairseq examples.